from typing import List, Dict

'''
Game 1: 3 blue, 4 red; 1 red, 2 green, 6 blue; 2 green

On va transformer ça en List[Dict[str, int]]
Game 1: [{"blue": 3, "red": 4},
         {"red": 1},
         {"green": 2, "blue": 6, "green": 2}]

Et faire cela pour toutes les lignes du fichier d'entrée
'''


def read() -> List[List[Dict[str, int]]]:
    with open('02/2.ex', 'r', encoding='utf-8') as f:
        lines: List[str] = f.read().splitlines()
    games: List[List[Dict[str, int]]] = []
    for game in lines:
        game_id, game_draws = game.split(': ') # ['Game 1', '3 blue, 4 red; 1 red, 2 green, 6 blue; 2 green']
        list_draws = game_draws.split('; ')    # ['3 blue, 4 red', '1 red, 2 green, 6 blue', '2 green']
        draws: List[Dict[str, int]] = []
        for draw in list_draws:         # draw <- '3 blue, 4 red' 
            draw = draw.split(', ')     # ['3 blue', '4 red']
            colors: Dict[str, int] = {}
            for ball in draw:           # ball <- '3 blue'
                count, color = ball.split(' ') # count <- '3' ; color <- 'blue'
                colors[color] = int(count)
            draws.append(colors)
        games.append(draws)
    return games


if __name__ == '__main__':
    games: List[List[Dict[str, int]]] = read()
    print(games)